%define ALD_Ver		2.0

Name:         zip

License:      BSD
Summary:      uzip - package and compress (archive) files
Version:      3.0
Release:      2

URL: http://www.info-zip.org

Source: %{name}30.tar.xz
Source2: %{name}30.2-patches.tgz

%define DestDir		/System
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%define target_ %{nil}
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 0
%define _build i386-pc-linux-gnu
%define _host %{_arch}-%{_os}%{_gnu}
%define target_ %{_host}-
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif
# ------------------- description ------------------------------------
%description
zip - package and compress (archive) files
# -------------------
%package tools
Summary:      zip-3.0 tools  zipcloak, zipnote, zipsplit
%description tools
zip-3.0 tools  zipcloak, zipnote, zipsplit

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}30

# patch from Fedora_36 zip-3.0-32.fc36.src.rpm  https://fedoraproject.org/ 

tar -xaf %SOURCE2
# This patch will probably be merged to zip 3.1
# http://www.info-zip.org/board/board.pl?m-1249408491/
patch -p1<patches/zip-3.0-exec-shield.patch
# Not upstreamed.
patch -p1<patches/zip-3.0-currdir.patch
# Not upstreamed.
patch -p1<patches/zip-3.0-time.patch
patch -p1<patches/man.patch
patch -p1<patches/zip-3.0-format-security.patch
patch -p1<patches/zipnote.patch

sed -i s:"-O3":: unix/configure
sed -i s:" \$(LFLAGS1) ":" \$(LFLAGS1) \$(LDFLAGS) ": unix/Makefile

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -ffunction-sections -fdata-sections"

CFLAGS="$OPTFLAGS -std=gnu99"
export LDFLAGS="-Wl,--gc-sections"

make -f unix/Makefile generic prefix=%{_prefix} CC=%{target_}gcc \
	"CFLAGS_NOOPT=-I. -DUNIX $CFLAGS" \
	&>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make -f unix/Makefile prefix=$RPM_BUILD_ROOT%{_prefix} MANDIR=$RPM_BUILD_ROOT%{_mandir}/man1 INSTALL="cp -p" install
cp -a LICENSE README WHERE $RPM_BUILD_ROOT%{docdir}/

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{_bindir}/zip
%{_mandir}/man1/zip.1.gz
%{docdir}

%files tools
%{_bindir}/zipcloak
%{_bindir}/zipnote
%{_bindir}/zipsplit
%{_mandir}/man1/zipcloak.1.gz
%{_mandir}/man1/zipnote.1.gz
%{_mandir}/man1/zipsplit.1.gz
